module DisplayState (newDState) where
import Graphics.Rendering.OpenGL
import Graphics.UI.GLUT

import Cube
import Action
import States
import VectorMaps
import Collision

------㏸ŃeNX`̋

data TextureFreeFall = FreeFallUpTexFlag | FreeFallDownTexFlag

------ǂ̐ݒ
walls:: WState -> (Vector3 PBound)
walls wst = (Vector3 (PBound ((-1.0) / (windowWH wst)) (1.0 / (windowWH wst))) (PBound (-1.0) 3.0)  (PBound (-1.0) 1.0))

------Gx[^tO
elevatorStartHeight:: WState -> GLfloat
elevatorStartHeight wst =  (minBorder (vectorElementY (walls wst))) + 0.01

------Gx[^I̍
elevatorEndHeight:: WState -> GLfloat
elevatorEndHeight wst = (minBorder (vectorElementY (walls wst))) + 1.8

------Gx[^㏸x
elevatorVelocity:: (Vector3 GLfloat)
elevatorVelocity = (Vector3 0 0.0002 0)

------W
wallsrefc :: (Vector3 GLfloat)
wallsrefc = Vector3 1.0  0.9 1.0

------
newDState :: DState -> KState -> WState -> DState
newDState dst kst wst = nextDState dst wst


------DStateBObjectׂĂɓƏՓ˂KpDStateԂ
nextDState :: DState -> WState -> DState
nextDState dst wst = DState $ collisionWithBObjects [ nextAction bOb wst | bOb <- (bObjs dst)]



------I
nextAction :: BObject -> WState -> BObject
nextAction bOb wst  = case (newActionID bOb wst) of
			FreeFall -> freeFallAct bOb wst
			Elevator -> elevatorAct bOb wst


------R
freeFallAct :: BObject -> WState -> BObject
freeFallAct bOb wst = 	let 	opos = objPosition bOb
				vel = objVelocity bOb
				acc = objAccele bOb
				velocity =  newVelocity3 (walls wst) wallsrefc opos  acc vel
      				oposition = nextPosition3  opos vel
				tex = objTexture bOb
		in  BObject oposition velocity acc (objWidth bOb) (newActionID bOb wst) (textureChange bOb tex)

------Gx[^[
elevatorAct :: BObject -> WState -> BObject
elevatorAct bOb wst = 	let 	opos = objPosition bOb
				vel = objVelocity bOb
				acc = objAccele bOb
      				oposition = nextPosition3  opos elevatorVelocity
				velocity = vel
				tex = objTexture bOb
		in  BObject oposition velocity acc (objWidth bOb) (newActionID bOb wst) (textureChange bOb tex)




------݂ActionID玟ActionID̎w֐̌
newActionID :: BObject -> WState -> ActionID
newActionID bOb wst= case (objActionID bOb) of
		Elevator  ->	newActionIDElevator bOb wst
		FreeFall  ->	newActionIDFreeFall bOb wst



------R̎ActionIĎ
newActionIDFreeFall :: BObject -> WState -> ActionID
newActionIDFreeFall bOb wst= case (elevatorCheck bOb wst) of 			
		True	-> Elevator 			--;Gx[^[
		False	-> FreeFall 			--;R

------Gx[^[̎ActionIĎ
newActionIDElevator :: BObject -> WState -> ActionID
newActionIDElevator bOb wst= case (elevatorEndCheck bOb wst) of 			
		True	-> FreeFall 			--;Gx[^[
		False	-> Elevator 			--;R

------Gx[^[邩̔
elevatorCheck :: BObject -> WState -> Bool
elevatorCheck bOb wst= if ((vectorElementY $ objPosition bOb) < (elevatorStartHeight wst)) && ((abs . vectorElementY $ objVelocity bOb) < 0.0001)
			then	True
			else	False

------Gx[^[I邩̔
elevatorEndCheck :: BObject -> WState -> Bool
elevatorEndCheck bOb wst= if ((vectorElementY $ objPosition bOb) >= (elevatorEndHeight wst))
			then	True
			else	False


------BObject̏ԂɂăeNX`̕ύX

textureChange :: BObject -> TexObjDataID -> TexObjDataID
textureChange bObj tObjID = case (textureChangeBoundFlag bObj) of	
			FreeFallUpTexFlag 	-> (TexObjDataID (texGroup tObjID) 1)
			FreeFallDownTexFlag     -> (TexObjDataID (texGroup tObjID) 0) 
 



------eNX`̕ύX̔
textureChangeBoundFlag :: BObject -> TextureFreeFall
textureChangeBoundFlag bObj = if ((objActionID bObj) == FreeFall ) && ((vectorElementY $ objVelocity bObj) > 0.0)	
					then FreeFallUpTexFlag									
					else FreeFallDownTexFlag
