module VectorMaps
(
vectorElementY
,vectorAdd
,vectorSubtract
,vectorScalar
,vectorNorm
,vectorNomalize
,vectorInnerProduct
) where


import Graphics.Rendering.OpenGL
import Control.Applicative 
import States



------xNg𔲂
vectorElementY :: (Vector3 a) -> a
vectorElementY (Vector3 x y z) = y

-----xNg̉@
vectorAdd :: (Vector3 GLfloat) -> (Vector3 GLfloat) ->  (Vector3 GLfloat)
vectorAdd u v = (+) <$> u <*> v 

-----xNǧZ
vectorSubtract :: (Vector3 GLfloat) -> (Vector3 GLfloat) ->  (Vector3 GLfloat)
vectorSubtract u v = (-) <$> u <*> v 

-----XJ[{
vectorScalar :: GLfloat -> (Vector3 GLfloat) -> (Vector3 GLfloat)  
vectorScalar a (Vector3 x y z) = (Vector3 (a * x) (a * y) (a * z))

-----xNg̃m
vectorNorm ::  (Vector3 GLfloat) -> GLfloat
vectorNorm (Vector3 x y z) = sqrt (x^2 + y^2 + z^2)

-----xNg̐K
vectorNomalize :: (Vector3 Float) -> (Vector3 Float) 
vectorNomalize v = vectorScalar (1 / vectorNorm v) v

-----xNg̓
vectorInnerProduct :: Num a => (Vector3 a) -> (Vector3 a) -> a 
vectorInnerProduct (Vector3 a b c) (Vector3 x y z) = a * x + b * y + c * z  




